Loading...
Searching...
No Matches
Finite Impulse Response (FIR) Interpolator
Signal Processing Functions | Signal Processing Functions » Finite Impulse Response (FIR) Decimator

## Functions

void | ne10_fir_interpolate_float_c (const ne10_fir_interpolate_instance_f32_t *S, ne10_float32_t *pSrc, ne10_float32_t *pDst, ne10_uint32_t blockSize)
| Processing function for the floating-point FIR interpolator.

## Detailed Description

  These functions combine an upsampler (zero stuffer) and an FIR filter. They are used in multirate systems for increasing the sample rate of a signal without introducing high frequency images. Conceptually, the functions are equivalent to the block diagram below:
  Components included in the FIR Interpolator functions
  After upsampling by a factor of `L`, the signal should be filtered by a lowpass filter with a normalized cutoff frequency of `1/L` in order to eliminate high frequency copies of the spectrum. The user of the function is responsible for providing the filter coefficients.

The FIR interpolator functions provided in the CMSIS DSP Library combine the upsampler and FIR filter in an efficient manner. The upsampler inserts `L-1` zeros between each sample. Instead of multiplying by these zero values, the FIR filter is designed to skip them. This leads to an efficient implementation without any wasted effort. The functions operate on blocks of input and output data. `pSrc` points to an array of `blockSize` input values and `pDst` points to an array of `blockSize*L` output values.

The library provides functions for floating-point data types.

Algorithm:
  The functions use a polyphase filter structure:

         y[n] = b[0] * x[n] + b[L]   * x[n-1] + ... + b[L*(phaseLength-1)] * x[n-phaseLength+1]
         y[n+1] = b[1] * x[n] + b[L+1] * x[n-1] + ... + b[L*(phaseLength-1)+1] * x[n-phaseLength+1]
         ...
         y[n+(L-1)] = b[L-1] * x[n] + b[2*L-1] * x[n-1] + ....+ b[L*(phaseLength-1)+(L-1)] * x[n-phaseLength+1]

  This approach is more efficient than straightforward upsample-then-filter algorithms. With this method the computation is reduced by a factor of `1/L` when compared to using a standard FIR filter.

  `pCoeffs` points to a coefficient array of size `numTaps`. `numTaps` must be a multiple of the interpolation factor `L` and this is checked by the initialization functions. Internally, the function divides the FIR filter's impulse response into shorter filters of length `phaseLength=numTaps/L`. Coefficients are stored in time reversed order.

         {b[numTaps-1], b[numTaps-2], b[N-2], ..., b[1], b[0]}

  `pState` points to a state array of size `blockSize + phaseLength - 1`. Samples in the state buffer are stored in the order:

         {x[n-phaseLength+1], x[n-phaseLength], x[n-phaseLength-1], x[n-phaseLength-2]....x[0], x[1], ..., x[blockSize-1]}

  The state variables are updated after each block of data is processed, the coefficients are untouched.

Instance Structure
  The coefficients and state variables for a filter are stored together in an instance data structure. A separate instance structure must be defined for each filter. Coefficient arrays may be shared among several instances while state variable array should be allocated separately. There are separate instance structure declarations for each of the 3 supported data types.

Initialization Functions
  There is also an associated initialization function for each data type. The initialization function performs the following operations:
  - Sets the values of the internal structure fields.
  - Zeros out the values in the state buffer.
  - Checks to make sure that the length of the filter is a multiple of the interpolation factor.

  Use of the initialization function is optional. However, if the initialization function is used, then the instance structure cannot be placed into a const data section. To place an instance structure into a const data section, the instance structure must be manually initialized. The code below statically initializes each of the 3 different data type filter instance structures

      ne10_fir_interpolate_instance_f32_t S = {L, phaseLength, pCoeffs, pState};

  where `L` is the interpolation factor; `phaseLength=numTaps/L` is the length of each of the shorter FIR filters used internally, `pCoeffs` is the address of the coefficient buffer; `pState` is the address of the state buffer. Be sure to set the values in the state buffer to zeros when doing static initialization.

Fixed-Point Behavior
  Care must be taken when using the fixed-point versions of the FIR interpolate filter functions. In particular, the overflow and saturation behavior of the accumulator used in each function must be considered. Refer to the function specific documentation below for usage guidelines.

## Function Documentation

## ne10_fir_interpolate_float_c()

void ne10_fir_interpolate_float_c | ( | const ne10_fir_interpolate_instance_f32_t * | S,
|  | ne10_float32_t * | pSrc,
|  | ne10_float32_t * | pDst,
|  | ne10_uint32_t | blockSize
| ) |  |

Processing function for the floating-point FIR interpolator.

Parameters

  [in] | *S | points to an instance of the floating-point FIR interpolator structure.
  [in] | *pSrc | points to the block of input data.
  [out] | *pDst | points to the block of output data.
  [in] | blockSize | number of input samples to process per call.

Returns
  none.

Definition at line 712 of file NE10_fir.c.